Subject: `guix pull` fails due to with-grafts in GUIX_BUILD_OPTIONS

From: "msglm" <[email-masked]>
Date: Sat, 20 Jan 2024 18:05:33 -0600

When I invoke `guix pull` when `GUIX_BUILD_OPTIONS` contains a call for
`--with-graft`, `guix pull` fails due to `with-graft` not being a valid
option for `guix pull`:

Command-line transcript:
guix pull
guix pull: error: with-graft=gnutls=[email-masked]: unrecognized option

Having `guix pull` ignore `GUIX_BUILD_OPTIONS` may be a hack fix, but it
could break other people's workflows since `guix pull` has some options for
building (i.e: `--cores` and `--no-grafts`).

Suggestions:

Adding `with-graft` support to guix pull (if that's even applicable). 
Having guix-pull just ignore the option and return a warning. 
Split up GUIX_BUILD_OPTIONS into a per-command set of flags (i.e:
GUIX_BUILD_OPTIONS_PULL).